/* Compile flags */

#define STREAMING_AUDIO
//#define OVERL_DEBUG

/* Source image defines */

#define SRC_WIDTH 384
#define SRC_HEIGHT 384

/* Font defines */

#define FONT_WIDTH 512
#define CHAR_WIDTH 14

/* Screen defines */

#define SCREEN_WIDTH 360
#define SCREEN_HEIGHT 240
#define VX 32
#define VY 16
#define VW 292
#define VH 176

/* Game related defines and limits */

#define SWITCH_CHAR_START 'a'
#define SWITCH_CHAR_END   'f'
#define TELEPORT_CHAR_START 'i'
#define TELEPORT_CHAR_END   'n'

#define MAXBOMBS 32
#define MAXSWITCHES (SWITCH_CHAR_END-SWITCH_CHAR_START+1)
#define MAXTELEPORTES (TELEPORT_CHAR_END-TELEPORT_CHAR_START+1)
#define MAX_DRONES 4
#define FIELD_MOVE_INCR 3
#define MAX_SONGS 16

/* Bomb chain reaction delay */

#define BOMB_CHAIN_DELAY 4

/* Screen DMA Flags */

#define OVERDMAFLAGS  (DMA_PIXEL_WRITE | ((SCREEN_WIDTH/8)<<16) | (2<<4) | (0<<11))                                          
#define DMAFLAGS  (DMA_PIXEL_WRITE | ((SCREEN_WIDTH/8)<<16) | (5<<4) | (0<<11))                                          
#define NUM_BUFFERS 3

/* Convert 32bpp to 16bpp */

#define C32bppTo16bbp(A) (((A)&0xfc000000) | (((A)&0x00f80000)<<2) | (((A)&0x0000f800)<<5))

/* Tile flags */

#define ACTIVATED 0x00000001   /* tile contains activated bomb */
#define TELEDEST  0x00000002   /* tile is teleport destination, teleport number in the upper 16 bits */

/* Explosion areas */

#define AREA_START 24

#define SMALL_BOMB_AREA_SIZE 1
#define MEDIUM_BOMB_AREA_SIZE 5
#define BIG_BOMB_AREA_SIZE 13

#define SMALL_BOMB_ACT_SIZE 5
#define MEDIUM_BOMB_ACT_SIZE 13
#define BIG_BOMB_ACT_SIZE 25

/* Tile types */

#define TILE 0
#define SMALLBOMB 1
#define MEDBOMB 2
#define BIGBOMB 3
#define WATER 4
#define ICE 5
#define BROKEN 6

#define DROP0_0 7
#define DROP0_1 8
#define DROP0_2 9
#define DROP0_3 10

#define DROP1_0 11
#define DROP1_1 12
#define DROP1_2 13
#define DROP1_3 14

#define DROP2_0 15
#define DROP2_1 16
#define DROP2_2 17
#define DROP2_3 18

#define DROP3_0 19
#define DROP3_1 20
#define DROP3_2 21
#define DROP3_3 22

#define SHIELD 23

#define EXPLOSION_0 24
#define EXPLOSION_1 25
#define EXPLOSION_2 26
#define EXPLOSION_3 27
#define EXPLOSION_4 28
#define EXPLOSION_5 29
#define EXPLOSION_6 30

#define SAVETILE 31
#define TELEPORT 32

#define SWITCH_OFF 33
#define SWITCH_ON 34

#define BIGMINE 35
#define SMALLMINE 36

#define DRONE_0 37
#define DRONE_1 38
#define DRONE_2 39
#define DRONE_3 40

#define DROP_SLEEP_0 41
#define DROP_SLEEP_1 42

#define SPINACH 43
#define SPARKLE 44

/* Drop animations */

#define DROP_DROWNING     0x01
#define DROP_START_DROWNING     ((40<<16)|DROP_DROWNING)
#define DROP_TELEPORTING 0x02
#define DROP_START_TELEPORTING ((24<<16)|DROP_TELEPORTING)
#define DROP_HALF_TELEPORTING ((12<<16)|DROP_TELEPORTING)

/* Timeouts */

#define SHIELD_TIME 100
#define SPINACH_TIME 400
